; 
    include \masm32\include\masm32rt.inc
; 

    GethWnd MACRO
      push 1
      call QEinterface
      EXITM <eax>
    ENDM

    GethEdit MACRO
      push 2
      call QEinterface
      EXITM <eax>
    ENDM

    .data?
      hWnd dd ?
      hEdit dd ?

    .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    switch reason
      case DLL_PROCESS_ATTACH
        mov eax, TRUE
      endsw

    ret

LibMain endp

; 

PiEntryPoint proc QEinterface:DWORD

    LOCAL tlen  :DWORD
    LOCAL ptxt  :DWORD
    LOCAL cr    :CHARRANGE

    mov hWnd, GethWnd()
    mov hEdit, GethEdit()

    invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR cr  ; get the selection range

  ; -----------------------------
  ; check if any text is selected
  ; -----------------------------
    mov eax, cr.cpMin
    cmp eax, cr.cpMax
    jne @F

    fn MessageBox,hWnd,"Please select a block of text first","Sorry ....",MB_OK
    ret

  @@:
  ; ------------------------------
  ; calculate the selection length
  ; ------------------------------
    mov eax, cr.cpMax
    sub eax, cr.cpMin
    mov tlen, eax

    mov ptxt, alloc(tlen)                           ; allocate memory of the selected text length

    invoke SendMessage,hEdit,EM_GETSELTEXT,0,ptxt   ; get the original selection

    fn MessageBox,hWnd,ptxt,"Original Selection",MB_OK

    mov ptxt, rev$(ptxt)                            ; reverse the selected text
    invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,ptxt    ; replace the text
    invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr  ; reselect the same text length

    fn MessageBox,hWnd,ptxt,"Reversed Selection",MB_OK

    mov ptxt, rev$(ptxt)                            ; reverse the selected text again
    invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,ptxt    ; replace the text
    invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr  ; reselect the same text length

    free ptxt                                       ; free the memory before exiting

    ret

PiEntryPoint endp

; 

end LibMain
